// tissue p-system simulator
// copyright 2008, 2009 jamie twycross, jpt AT cs.nott.ac.uk
// released under GNU GPL version 3

#if HAVE_CONFIG_H
	#include <config.h>
#endif

#include <iostream>
#include <stdio.h>
#include <stdlib.h>
#include <strings.h>
#include <mcss/mcss.h>

using namespace std;
using namespace Simulation;

int main(int argc, char **argv)
{
	#ifdef HAVE_MPI
	// initialise mpi
	MPI_Init(&argc, &argv);
	atexit((void (*)()) MPI_Finalize);
	#endif

	// parse command line and read in parameters
	if(argc == 1)
		#ifdef HAVE_MPI
		fprintf(stderr, "mcss version %s (MPI)\n", VERSION);
		#else
		fprintf(stderr, "mcss version %s\n", VERSION);
		#endif
	SimulationParameters parameters;
	parameters.read(argc, argv);

	// create p-system from parameters specified in parameter file
	Psystem psystem(parameters);

	// dump model if not simulating
	if(parameters.dump) {
		char dump_file[PARAMETER_STR_MAX];
		char *ptr = rindex(parameters.data_file, '.');
		*ptr = '\0';
		snprintf(dump_file, 1024, "%s.dump", parameters.data_file);
		psystem.dump(dump_file);
		exit(EXIT_SUCCESS);
	}

	// run simulation
	psystem.execute(parameters.max_time);

	exit(EXIT_SUCCESS);
}
